%global drv_vendor OVN
%global pkgname networking-ovn
%global srcname networking_ovn
%global docpath doc/build/html

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:           python-%{pkgname}
Version:        4.0.4
Release:        8%{?dist}
Summary:        %{drv_vendor} OpenStack Neutron driver

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/%{pkgname}
Source0:        https://tarballs.openstack.org/%{pkgname}/%{pkgname}-%{upstream_version}.tar.gz
Source1:        networking-ovn-metadata-agent.service
# patches_ignore=DROP-IN-RPM
# patches_base=4.0.4
Patch0001: 0001-Fix-test_models_sync-functional-test.patch
Patch0002: 0002-Add-support-for-VLAN-type-networks-in-networking-ovn.patch
Patch0003: 0003-Support-ports-belonging-to-Neutron-DHCP-agents.patch
Patch0004: 0004-Add-support-for-global-DHCP-options-with-OVN-DHCP.patch
Patch0005: 0005-Add-unknown-to-the-address-list-if-the-port-s-port-s.patch
Patch0006: 0006-Maintenance-Log-how-long-the-synchronization-took.patch
Patch0007: 0007-Spawn-ovn-northd-for-functional-tests.patch
Patch0008: 0008-Clean-MAC_Binding-entries-when-dis-associating-a-FIP.patch
Patch0009: 0009-Maintenance-task-Enhance-debug-logging.patch
Patch0010: 0010-funcional-skip-tests-using-Port-Groups.patch
Patch0011: 0011-Added-one-more-empty-line.patch
Patch0012: 0012-DownstreamOnly-Maintenance-Port-groups-migration-wai.patch
Patch0013: 0013-Add-Neutron-network-id-to-OVN-LRPs.patch
Patch0014: 0014-Set-binding-profile-directly-from-OVNTrunkDriver-red.patch
Patch0015: 0015-Work-around-potential-double-row.delete-call.patch
Patch0016: 0016-Support-for-Router-Scheduling-on-addition-removal-of.patch
Patch0017: 0017-Only-set-unknown-in-LSP-that-makes-sense.patch
Patch0018: 0018-Metadata-agent-fetch-ovn-bridge-from-OVSDB-and-not-f.patch
Patch0019: 0019-Fix-duplication-of-method-_log_maintenance_inconsist.patch
Patch0020: 0020-OVN-Delete-NAT-entry-first-on-any-FIP-update.patch
Patch0021: 0021-OVN-Remove-VLAN-check-when-setting-external_mac.patch
Patch0022: 0022-Propagate-mtu-to-all-subnets.patch
Patch0023: 0023-Fix-revision-number-race-condition-with-attaching-ro.patch
Patch0024: 0024-Exclude-all-device_ids-that-belong-to-Neutron-DHCP-A.patch
Patch0025: 0025-Fix-wrong-path-in-doc-config.patch
Patch0026: 0026-Bump-up-os-log-merger-to-latest-version.patch
Patch0027: 0027-Store-the-FIP-associated-to-a-port-in-the-OVN-Northb.patch
Patch0028: 0028-Centralize-traffic-when-LB-and-member-has-FIP.patch
Patch0029: 0029-Blacklist-test_multiple_ports_portrange_remote-for-O.patch
Patch0030: 0030-Use-rally-openstack-1.7.0-for-stable-queens.patch
Patch0031: 0031-Don-t-reschedule-hosts-unless-we-need-to.patch
Patch0032: 0032-Revert-Exclude-all-device_ids-that-belong-to-Neutron.patch
Patch0033: 0033-Exclude-all-device_ids-that-belong-to-Neutron-DHCP-A.patch
Patch0034: 0034-Pass-Domain-Name-to-dhcp-options.patch
Patch0035: 0035-Change-passed-domain_name-parameter-value.patch
Patch0036: 0036-Add-missing-white-line.patch
Patch0037: 0037-OVN-Make-_delete_port-more-error-resilent.patch
Patch0038: 0038-OVN-metadata-Adding-ERROR-trace-upon-unexpected-data.patch
Patch0039: 0039-Only-set-unknown-in-LSP-that-makes-sense.patch
Patch0040: 0040-Use-OVN-mech-driver-OVSDB-connections-for-l3-plugin.patch
Patch0041: 0041-OVN-Do-not-delete-port-s-revision-on-RowNotFound.patch
Patch0042: 0042-Remove-the-release-note-job.patch
Patch0043: 0043-Add-support-for-virtual-port-type.patch
Patch0044: 0044-mech_driver.OVNMechanismDriver-_ovn_client-is-a-read.patch
Patch0045: 0045-Fix-ovn-db-sync-util-after-removing-l3-ovsdb-connect.patch
Patch0046: 0046-test_router-Verify-the-creation-and-removal-of-a-lrp.patch
Patch0047: 0047-Fix-broken-gate-because-of-OVS-module-compilation.patch
Patch0048: 0048-OVN-Don-t-set-virtual-port-type-on-ports-with-simila.patch
Patch0049: 0049-Set-class-ovsdb_conection-to-None.patch
Patch0050: 0050-Add-support-for-global-DHCP-options-with-OVN-DHCP.patch
Patch0051: 0051-Add-unknown-to-the-address-list-if-the-port-s-port-s.patch
Patch0052: 0052-Only-set-unknown-in-LSP-that-makes-sense.patch
Patch0053: 0053-Exclude-all-device_ids-that-belong-to-Neutron-DHCP-A.patch
Patch0054: 0054-Revert-Exclude-all-device_ids-that-belong-to-Neutron.patch
Patch0055: 0055-Exclude-all-device_ids-that-belong-to-Neutron-DHCP-A.patch

BuildArch:      noarch
BuildRequires:  git
BuildRequires:  python2-devel
BuildRequires:  python2-debtcollector
BuildRequires:  python2-mock
BuildRequires:  openstack-macros

# This is required to generate the networking-ovn.ini configuration file
BuildRequires:  python-neutron

BuildRequires:  python2-oslo-config
BuildRequires:  python2-oslo-log
BuildRequires:  python2-openstackdocstheme
BuildRequires:  python2-ovsdbapp
BuildRequires:  python2-pbr
BuildRequires:  python2-sphinx


# python-openvswitch is not included in openstack-neutron-common.
# Its needed by networking-ovn.
Requires:       openstack-neutron-common
Requires:       python2-babel
Requires:       python2-futurist >= 1.2.0
Requires:       python2-netaddr
Requires:       python2-neutron-lib >= 1.13.0
Requires:       python2-oslo-config >= 2:5.1.0
Requires:       python-openvswitch >= 2.8.0
Requires:       python2-pbr
Requires:       python2-six
Requires:       python2-tenacity
Requires:       python2-ovsdbapp >= 0.8.0
Requires:       python2-pyOpenSSL >= 16.2.0

%description
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

This package contains %{drv_vendor} networking driver which provides
integration between OpenStack Neutron and OVN.


%package metadata-agent
Summary:        networking-ovn metadata agent
BuildRequires:  systemd
Requires:       python-%{pkgname} = %{version}-%{release}
Requires:       openvswitch >= 2.8.0
%{?systemd_requires}

%description metadata-agent
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

This package contains the agent that implements the metadata proxy so that VM's
can retrieve metadata from OpenStack Nova.

%prep
%autosetup -n %{pkgname}-%{upstream_version} -S git

# Let's handle dependencies ourselves
%py_req_cleanup

# Kill egg-info in order to generate new SOURCES.txt
rm -rf {srcname}.egg-info


%build
export SKIP_PIP_INSTALL=1
%{__python2} setup.py build
%{__python2} setup.py build_sphinx
rm -rf %{docpath}/.{doctrees,buildinfo}

# Generate config file
PYTHONPATH=. oslo-config-generator --namespace networking_ovn --output-file networking-ovn.ini
PYTHONPATH=. oslo-config-generator --namespace networking_ovn.metadata.agent --output-file networking-ovn-metadata-agent.ini


%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# Remove unused files
rm -rf %{buildroot}%{python2_sitelib}/bin
rm -rf %{buildroot}%{python2_sitelib}/doc
rm -rf %{buildroot}%{python2_sitelib}/tools


# Move config file to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
mv networking-ovn.ini %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
mv networking-ovn-metadata-agent.ini %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
chmod 640 %{buildroot}%{_sysconfdir}/neutron/plugins/*/*.ini

# Create configuration directories for all services that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/neutron/conf.d/networking-ovn-metadata-agent

# Install systemd units
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/networking-ovn-metadata-agent.service

%post metadata-agent
%systemd_post networking-ovn-metadata-agent.service


%preun metadata-agent
%systemd_preun networking-ovn-metadata-agent.service


%postun metadata-agent
%systemd_postun_with_restart networking-ovn-metadata-agent.service

%files
%license LICENSE
%doc %{docpath}
%{python2_sitelib}/%{srcname}
%{python2_sitelib}/%{srcname}-*.egg-info
%{_bindir}/neutron-ovn-db-sync-util
%dir %{_sysconfdir}/neutron/plugins/networking-ovn
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/plugins/networking-ovn/networking-ovn.ini

%files metadata-agent
%license LICENSE
%{_bindir}/networking-ovn-metadata-agent
%{_unitdir}/networking-ovn-metadata-agent.service
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/plugins/networking-ovn/networking-ovn-metadata-agent.ini
%dir %{_sysconfdir}/neutron/conf.d/networking-ovn-metadata-agent

%changelog
* Wed Sep 09 2020 Miguel Garcia <mgarciac@redhat.com> 4.0.4-8
- Revert "Exclude all device_ids that belong to Neutron DHCP Agent"
- Add 'unknown' to the address list if the port's port security is disabled (rhbz#1671809)
- Set class ovsdb_conection to None
- [OVN] Don't set virtual port type on ports with similar addresses
- Fix broken gate because of OVS module compilation
- test_router: Verify the creation and removal of a lrp
- Fix ovn-db-sync-util after removing l3 ovsdb connection
- mech_driver.OVNMechanismDriver "_ovn_client" is a read-only property
- Add support for virtual port type
- Remove the release note job
- [OVN] Do not delete port's revision on RowNotFound
- Use OVN mech driver OVSDB connections for l3 plugin

* Mon Jun 08 2020 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.4-7
- [OVN][metadata] Adding ERROR trace upon unexpected data (rhbz#1826730)
- [OVN]: Make _delete_port() more error-resilent (rhbz#1826730)

* Fri May 22 2020 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.4-6
- Add missing white line (rhbz#1836907)

* Fri May 22 2020 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.4-5
- Change passed domain_name parameter value (rhbz#1836907)
- Pass Domain Name to dhcp options (rhbz#1836907)
- Revert "Exclude all device_ids that belong to Neutron DHCP Agent"

* Wed May 06 2020 Miguel Garcia <mgarciac@redhat.com> 4.0.4-4
- Don't reschedule hosts unless we need to
- Use rally-openstack 1.7.0 for stable/queens
- Blacklist test_multiple_ports_portrange_remote for OVN stable/queens
- Centralize traffic when LB and member has FIP
- Store the FIP associated to a port in the OVN Northbound db.
- Bump-up os-log-merger to latest version
- Fix wrong path in doc config
- Exclude all device_ids that belong to Neutron DHCP Agent
- Fix revision number race condition with attaching router interfaces

* Wed Apr 22 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 4.0.4-3
- Propagate mtu to all subnets (rhbz#1685634)
- [OVN] Remove VLAN check when setting external_mac (rhbz#1789836)

* Fri Jan 31 2020 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.4-2
- [OVN] Delete NAT entry first on any FIP update (rhbz#1796399)
- Fix duplication of method _log_maintenance_inconsistencies()

* Wed Jan 29 2020 Miguel Garcia <mgarciac@redhat.com> 4.0.4-1
- Update to 4.0.4
- Metadata agent: fetch ovn-bridge from OVSDB and not from config

* Fri Jan 17 2020 Terry Wilson <twilson@redhat.com> 4.0.3-21
- Avoid port group creation race (rhbz#1737432)

* Mon Jan 13 2020 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.3-20
- Only set "unknown" in LSP that makes sense (rhbz#1789764)
- Support for Router Scheduling on addition/removal of chassis (rhbz#1565563)

* Fri Dec 20 2019 Terry Wilson <twilson@redhat.com> 4.0.3-19
- Work around potential double row.delete() call (rhbz#1766410)

* Tue Dec 17 2019 Flavio Fernandes <flaviof@redhat.com> 4.0.3-18
- Set binding profile directly from OVNTrunkDriver (redo + cont.) (rhbz#1765640)

* Mon Dec 16 2019 Flavio Fernandes <flaviof@redhat.com> 4.0.3-17
- Add Neutron network id to OVN LRPs (rhbz#1780381)

* Wed Nov 20 2019 Lucas Gomez Martins <lmartins@redhat.com> 4.0.3-16
- [DownstreamOnly] Maintenance: Port groups migration, wait for OVS upgrade (rhbz#1766575)
- Added one more empty line.
- funcional: skip tests using Port Groups (rhbz#1769249)

* Mon Oct 21 2019 Flavio Fernandes <flaviof@redhat.com> 4.0.3-15
- Do not lose router logical port upon subnet add on the external net (rhbz#1761389)

* Wed Oct 16 2019 Terry Wilson <twilson@redhat.com> 4.0.3-14
- Fix evacuation when host dies uncleanly (rhbz#1727856)

* Thu Oct 10 2019 Steve Linabery <slinaber@redhat.com> 4.0.3-13
- Make use of OVS 2.11 in stable/queens
- Always add NAT rule to a LR when updating a FIP
- Maintenance task: Enhance debug logging
- Replace httplib2 with requests in metadata agent
- Floating IP does not work with VLAN tenant networks
- Fix metadata agent proxy list updates race condition
- OpenDev Migration Patch
- Replace openstack.org git:// URLs with https://

* Thu Oct 03 2019 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.3-12
- Fix for getting port groups while using OVS up to 2.9 (rhbz#1545344)
- Fix Tempest and Unit tests (rhbz#1545344)
- Removing leftovers from subnet Port Groups (rhbz#1545344)
- Fix ovn db sync tool to support Port Groups (rhbz#1545344)
- Attempt the migration to Port Groups from Maintenance worker (rhbz#1545344)
- Support Port Groups in networking-ovn (rhbz#1545344)
- Add Port Groups ACLs related code from ovsdbapp (rhbz#1545344)

* Wed Sep 04 2019 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.3-11
- Update port_status to ACTIVE during live-migration (rhbz#1642106)
- Do not modify passed by reference variables in mechanism_driver (rhbz#1746880)

* Wed Jul 03 2019 Lucas Gomez Martins <lmartins@redhat.com> 4.0.3-10
- Maintenance task: Fix race condition at resource creation (rhbz#1725750)

* Mon Jul 01 2019 Jakub Libosvar <libosvar@redhat.com> 4.0.3-9
- Spawn ovn-northd for functional tests (rhbz#1686863)
- Maintenance: Log how long the synchronization took (rhbz#1686863)
- Add 'unknown' to the address list if the port's port security is disabled (rhbz#1671809)

* Fri Jun 28 2019 Lucas Gomez Martins <lmartins@redhat.com> 4.0.3-8
- Don't wait for metadata service unnecessarily (rhbz#1691044)

* Wed Jun 05 2019 Maciej Józefczyk <mjozefcz@redhat.com> 4.0.3-7
- Do not set port addresses on LSP while port not bound (rhbz#1707241)

* Fri Apr 05 2019 Jon Schlueter <jschluet@redhat.com> 4.0.3-6
- update to stable/queens (rhbz#1696833)
- Use vhost user client mode, instead of server
- Fix functional tests
- Fix unbound "mac" variable
- Support per network dns domain name in internal OVN dns

* Tue Mar 19 2019 Kamil Sambor <ksambor@redhat.com> 4.0.3-5
- Add 'unknown' to the address list if the port's port security is disabled (rhbz#1671809)

* Thu Feb 28 2019 Daniel Alvarez <dalvarez@redhat.com> 4.0.3-4
- Add IPv6 default route to OVN Logical Router (rhbz#1656018)

* Thu Feb 21 2019 Lucas Gomez Martins <lmartins@redhat.com> 4.0.3-3
- Extend ml2 plugin to notify nova of port status (rhbz#1642106)

* Thu Feb 21 2019 Lucas Gomez Martins <lmartins@redhat.com> 4.0.3-2
- Add support for global DHCP options with OVN DHCP. (rhbz#1613482)
- Clean MAC_Binding entries when (dis)associating a FIP (rhbz#1642830)
- Support ports belonging to Neutron DHCP agents (rhbz#1610711)
- Add support for VLAN type networks in networking-ovn (rhbz#1661223)

* Fri Oct 19 2018 Jon Schlueter <jschluet@redhat.com> 4.0.3-1
- Update to 4.0.3 (rhbz#1640415)

* Thu Aug 30 2018 Daniel Alvarez <dalvarez@redhat.com> 4.0.2-4
- Fix gateway's router port marked as DOWN (rhbz#1560442)

* Thu Aug 30 2018 Daniel Alvarez <dalvarez@redhat.com> 4.0.2-3
- Set/unset external MAC addresses for NAT entry when port is up/down (rhbz#1608951)

* Tue Jul 24 2018 Jon Schlueter <jschluet@redhat.com> 4.0.2-2
- Fix: Router port always marked as DOWN (rhbz#1593755)
- Update to 4.0.2 (rhbz#1607993)
- Fix test_models_sync() functional test (rhbz#1564912)

* Thu Jul 05 2018 Jon Schlueter <jschluet@redhat.com> 4.0.1-3
- Strip the trailing '.' from the fqdn dns record stored in OVN NB DB (rhbz#1581332)
- bump to 4.0.1 tarball

* Tue Jul 03 2018 Daniel Alvarez <dalvarez@redhat.com> 4.0.1-0.20180420150812.c7c16d4
- Set ovsdb probe interval to 1 minute on the client side (rhbz#1578312)

* Thu Jun 28 2018 Numan Siddique <nusiddiq@redhat.com> 4.0.1-0.20180420150811.c7c16d4
- Fix error in router port maintenance code (rhbz#1593755)
- Add default dns_server option in DHCP_Options table (rhbz#1582512)
- Fix test_models_sync() functional test (rhbz#1433533)
- Maintenance: Add functional tests for database sync task (rhbz#1433533)

* Mon May 14 2018 Daniel Alvarez <dalvarez@redhat.com> 4.0.1-0.20180420150810.c7c16d4
- Handle port's 'port_security_enabled' flag when adding ACLs (rhbz#1575843)

* Thu Apr 26 2018 Daniel Alvarez <dalvarez@redhat.com> 4.0.1-0.20180420150809.c7c16d4
- L3HA: Take priorities into account in least loaded scheduling (rhbz#1562731)
- Clear binding:host_id when a subport is removed from a trunk (rhbz#1563678)
- Do not use a transaction for get_logical_port_chassis_and_datapath() (rhbz#1552545)

* Wed Apr 25 2018 Jon Schlueter <jschluet@redhat.com> 4.0.1-0.20180420150808.c7c16d4
- maintain python-openvswitch Req

